//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "FlexBase.hpp"
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Tabs.hpp>
#include <Dialogs.hpp>
#include <ActnList.hpp>
#include <ExtDlgs.hpp>
#include <Menus.hpp>

static TColor DefaultPalette[] = {
   (TColor)0x000000,
   (TColor)0x191919,
   (TColor)0x333333,
   (TColor)0x4C4C4C,
   (TColor)0x666666,
   (TColor)0x808080,
   (TColor)0x999999,
   (TColor)0xB2B2B2,
   (TColor)0xE5E5E5,
   (TColor)0xFFFFFF,
   (TColor)0x000080,
   (TColor)0x008000,
   (TColor)0x008080,
   (TColor)0x800000,
   (TColor)0x800080,
   (TColor)0x808000,
   (TColor)0x808080,
   (TColor)0xC0C0C0,
   (TColor)0x0000FF,
   (TColor)0x00FF00,
   (TColor)0x00FFFF,
   (TColor)0xFF0000,
   (TColor)0xFF00FF,
   (TColor)0xFFFF00,
   (TColor)0x400000,
   (TColor)0xA00000,
   (TColor)0x004000,
   (TColor)0x404000,
   (TColor)0x804000,
   (TColor)0x408000,
   (TColor)0xC08000,
   (TColor)0xFF8000,
   (TColor)0x40FF00,
   (TColor)0x80FF00,
   (TColor)0x000040,
   (TColor)0x400040,
   (TColor)0x800040,
   (TColor)0x400080,
   (TColor)0xFF0080,
   (TColor)0x004080,
   (TColor)0x404080,
   (TColor)0xC08080,
   (TColor)0xFF8080,
   (TColor)0x00FF80,
   (TColor)0x80FF80,
   (TColor)0xFFFF80,
   (TColor)0x8000FF,
   (TColor)0x0080FF,
   (TColor)0x4080FF,
   (TColor)0x8080FF,
   (TColor)0xC080FF,
   (TColor)0xFF80FF,
   (TColor)0x80FFFF
};

#define DefaultPaletteCount (sizeof(DefaultPalette) / sizeof(TColor))

// Status bar panels
static const sbpSelected = 0;
static const sbpScale    = 1;

//---------------------------------------------------------------------------
class TfmMain : public TForm
{
__published:	// IDE-managed Components
        TImageList *imgMainTools;
        TImageList *imgDrawTools;
        TPanel *panColors;
        TDrawGrid *dgColors;
        TPanel *panView;
        TTabSet *tstSchemes;
        TSplitter *sptMain;
        TPanel *panFlex;
        TFlexPanel *fpMain;
        TStatusBar *sbrMain;
        TColorDialog *cd_Palette;
        TToolBar *tbrTools;
        TToolButton *tbtArrow;
        TToolButton *tbtShape;
        TToolButton *tbtPan;
        TToolButton *tbtZoom;
        TToolButton *tbtLine;
        TToolButton *tbtBox;
        TToolButton *tbtEllipse;
        TToolButton *tbtText;
        TToolButton *tbtPicture;
        TActionList *alMain;
        TAction *acFileNew;
        TAction *acFileOpen;
        TAction *acFileSave;
        TAction *acFileExit;
        TAction *acEditCut;
        TAction *acEditCopy;
        TAction *acEditPaste;
        TAction *acEditDelete;
        TAction *acZoomIn;
        TAction *acZoomOut;
        TAction *acZoom100;
        TOpenDialog *od_Main;
        TSaveDialog *sd_Main;
        TOpenPictureDialog *opd_Pictures;
        TToolBar *tbrMain;
        TToolButton *ToolButton10;
        TToolButton *ToolButton11;
        TToolButton *ToolButton12;
        TToolButton *ToolButton5;
        TToolButton *ToolButton14;
        TToolButton *ToolButton15;
        TToolButton *ToolButton16;
        TToolButton *ToolButton17;
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TToolButton *ToolButton3;
        TToolButton *ToolButton4;
        TPopupMenu *pmSchemes;
        TMenuItem *miSchemeNew;
        TMenuItem *miSchemeDelete;
        TMenuItem *miSchemeRename;
        TAction *acSchemeNew;
        TAction *acSchemeDelete;
        TAction *acSchemeRename;
        void __fastcall dgColorsDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall panColorsResize(TObject *Sender);
        void __fastcall sptMainMoved(TObject *Sender);
        void __fastcall dgColorsMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall tbtToolClick(TObject *Sender);
        void __fastcall acFileNewExecute(TObject *Sender);
        void __fastcall acFileOpenExecute(TObject *Sender);
        void __fastcall acFileSaveExecute(TObject *Sender);
        void __fastcall acFileExitExecute(TObject *Sender);
        void __fastcall acEditCutExecute(TObject *Sender);
        void __fastcall acEditCopyExecute(TObject *Sender);
        void __fastcall acEditPasteExecute(TObject *Sender);
        void __fastcall acEditDeleteExecute(TObject *Sender);
        void __fastcall acZoomInExecute(TObject *Sender);
        void __fastcall acZoomOutExecute(TObject *Sender);
        void __fastcall acZoom100Execute(TObject *Sender);
        void __fastcall fpMainNotify(TObject *Sender,
          TFlexControl *Control, TFlexNotify Notify);
        void __fastcall acSchemeNewExecute(TObject *Sender);
        void __fastcall acSchemeDeleteExecute(TObject *Sender);
        void __fastcall acSchemeRenameExecute(TObject *Sender);
        void __fastcall tstSchemesChange(TObject *Sender, int NewTab,
          bool &AllowChange);
private:	// User declarations
        bool FIniting;
        bool FIsFileLoading;
        bool FInspDataNeedUpdate;
        bool FInspPropsNeedUpdate;
        int FFilerProgress;
        AnsiString FFilename;
        TList *FToolbarItems;
        TList *FColors;
        void __fastcall RefreshColors();
        void __fastcall CheckTools();
        bool __fastcall CheckSave();
        void __fastcall DocChange();
public:		// User declarations
        __fastcall TfmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
