unit Main;

interface

uses
  {$IFDEF VER150} XPMan, {$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ToolWin, ComCtrls, FlexBase, ActnList, ClipBrd,
  FlexUtils, FlexControls, FlexProps, Tabs, ExtCtrls, Menus, ExtDlgs, Grids;

const
  // Status bar panels
  sbpSelected = 0;
  sbpScale    = 1;

  DefaultPallete: array[0..52] of TColor = (
   clNone,
   TColor($000000),
   TColor($191919),
   TColor($333333),
   TColor($4C4C4C),
   TColor($666666),
   TColor($7F7F7F),
   TColor($999999),
   TColor($B2B2B2),
   TColor($E5E5E5),
   TColor($FFFFFF),
   TColor($000080),
   TColor($008000),
   TColor($008080),
   TColor($800000),
   TColor($800080),
   TColor($808000),
   TColor($808080),
   TColor($C0C0C0),
   TColor($0000FF),
   TColor($00FF00),
   TColor($00FFFF),
   TColor($FF0000),
   TColor($FF00FF),
   TColor($FFFF00),
   TColor($C0C0C0),
   TColor($808080),
   TColor(COLOR_SCROLLBAR or $80000000),
   TColor(COLOR_BACKGROUND or $80000000),
   TColor(COLOR_ACTIVECAPTION or $80000000),
   TColor(COLOR_INACTIVECAPTION or $80000000),
   TColor(COLOR_MENU or $80000000),
   TColor(COLOR_WINDOW or $80000000),
   TColor(COLOR_WINDOWFRAME or $80000000),
   TColor(COLOR_MENUTEXT or $80000000),
   TColor(COLOR_WINDOWTEXT or $80000000),
   TColor(COLOR_CAPTIONTEXT or $80000000),
   TColor(COLOR_ACTIVEBORDER or $80000000),
   TColor(COLOR_INACTIVEBORDER or $80000000),
   TColor(COLOR_APPWORKSPACE or $80000000),
   TColor(COLOR_HIGHLIGHT or $80000000),
   TColor(COLOR_HIGHLIGHTTEXT or $80000000),
   TColor(COLOR_BTNFACE or $80000000),
   TColor(COLOR_BTNSHADOW or $80000000),
   TColor(COLOR_GRAYTEXT or $80000000),
   TColor(COLOR_BTNTEXT or $80000000),
   TColor(COLOR_INACTIVECAPTIONTEXT or $80000000),
   TColor(COLOR_BTNHIGHLIGHT or $80000000),
   TColor(COLOR_3DDKSHADOW or $80000000),
   TColor(COLOR_3DLIGHT or $80000000),
   TColor(COLOR_INFOTEXT or $80000000),
   TColor(COLOR_INFOBK or $80000000),
   clDefault
  );

type
  TfmMain = class(TForm)
    tbrTools: TToolBar;
    imgTools: TImageList;
    tbtArrow: TToolButton;
    tbtShape: TToolButton;
    tbtLine: TToolButton;
    tbtBox: TToolButton;
    tbtEllipse: TToolButton;
    tbtText: TToolButton;
    tbtPicture: TToolButton;
    tbtZoom: TToolButton;
    tbtPan: TToolButton;
    imgStdTools: TImageList;
    alMain: TActionList;
    acFileNew: TAction;
    acFileOpen: TAction;
    acFileSave: TAction;
    acFileExit: TAction;
    acEditCut: TAction;
    acEditCopy: TAction;
    acEditPaste: TAction;
    acEditDelete: TAction;
    od_Main: TOpenDialog;
    sd_Main: TSaveDialog;
    acZoomIn: TAction;
    acZoomOut: TAction;
    acZoom100: TAction;
    sbrMain: TStatusBar;
    panView: TPanel;
    pmSchemes: TPopupMenu;
    Action1: TAction;
    miSchemeNew: TMenuItem;
    miSchemeDelete: TMenuItem;
    miSchemeRename: TMenuItem;
    opd_Pictures: TOpenPictureDialog;
    sptColors: TSplitter;
    panFlexAndSchemes: TPanel;
    tstSchemes: TTabSet;
    cd_Main: TColorDialog;
    fpMain: TFlexPanel;
    CoolBar1: TCoolBar;
    panBarMain: TPanel;
    tbrMain: TToolBar;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton13: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    ToolButton23: TToolButton;
    ToolButton24: TToolButton;
    bvFlexDelim: TBevel;
    panToolDelimit: TPanel;
    panNCColors: TPanel;
    panColors: TPanel;
    dgColors: TDrawGrid;
    imgNCColorsCap: TImage;
    Bevel1: TBevel;
    ToolButton1: TToolButton;
    procedure acEditPasteUpdate(Sender: TObject);
    procedure acFileNewExecute(Sender: TObject);
    procedure acFileOpenExecute(Sender: TObject);
    procedure acFileSaveExecute(Sender: TObject);
    procedure acFileExitExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acEditCutExecute(Sender: TObject);
    procedure acEditCopyExecute(Sender: TObject);
    procedure acEditPasteExecute(Sender: TObject);
    procedure acEditDeleteExecute(Sender: TObject);
    procedure fpMainNotify(Sender: TObject; Control: TFlexControl;
      Notify: TFlexNotify);
    procedure ToolButtonClick(Sender: TObject);
    procedure acZoomInExecute(Sender: TObject);
    procedure acZoomOutExecute(Sender: TObject);
    procedure acZoom100Execute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tstSchemesChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure miSchemeNewClick(Sender: TObject);
    procedure miSchemeDeleteClick(Sender: TObject);
    procedure miSchemeRenameClick(Sender: TObject);
    procedure fpMainDblClick(Sender: TObject);
    procedure panColorsResize(Sender: TObject);
    procedure dgColorsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure sptColorsMoved(Sender: TObject);
    procedure dgColorsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    FFileName: string;
    procedure CheckTools;
    procedure DocChange;
    function  CheckSave: boolean;
    procedure RebuildColors;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

// TfmMain ////////////////////////////////////////////////////////////////////

procedure TfmMain.FormCreate(Sender: TObject);
begin
 LoadFlexCursors;
 fpMain.InDesign := true;
 fpMain.Modified := false;
 CheckTools;
 DocChange;
 RebuildColors;
end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 fpMain.UnselectAll;
end;

function TfmMain.CheckSave: boolean;
var ModalRes: word;
begin
 if not fpMain.Modified then begin
  Result := true;
  exit;
 end;
 Result := false;
 ModalRes := MessageDlg('Save changes?', mtWarning, [mbYes, mbNo, mbCancel], 0);
 case ModalRes of
  mrYes:
    begin
     acFileSave.Execute;
     if fpMain.Modified then exit;
    end;
  mrNo:
    ;
  mrCancel:
    exit;
 end;
 Result := true;
end;

procedure TfmMain.DocChange;
var i: integer;
begin
 // Update scheme tabs
 with tstSchemes.Tabs do begin
  BeginUpdate;
  try
   Clear;
   for i:=0 to fpMain.Schemes.Count-1 do Add(fpMain.Schemes[i].Name);
   tstSchemes.TabIndex := fpMain.Schemes.IndexOf(fpMain.ActiveScheme);
  finally
   EndUpdate;
  end;
 end;
end;

procedure TfmMain.CheckTools;
var IsSel: boolean;
begin
 // Flags
 IsSel := fpMain.SelectedCount > 0;
 // File
 acFileNew.Enabled := true;
 acFileOpen.Enabled := true;
 acFileSave.Enabled := fpMain.Modified;
 // Edit
 acEditDelete.Enabled := IsSel;
 acEditCut.Enabled := IsSel;
 acEditCopy.Enabled := IsSel;
 // Status
 sbrMain.Panels[sbpSelected].Text := 'Selected: '+IntToStr(fpMain.SelectedCount);
end;

procedure TfmMain.acEditPasteUpdate(Sender: TObject);
begin
 acEditPaste.Enabled := Clipboard.HasFormat(CF_FLEXDOC);
end;

procedure TfmMain.fpMainNotify(Sender: TObject; Control: TFlexControl;
  Notify: TFlexNotify);
begin
 case Notify of
  fnSelect:
    CheckTools;
 end;
end;

procedure TfmMain.ToolButtonClick(Sender: TObject);
begin
 if Sender is TToolButton then TToolButton(Sender).Down := true;
 with fpMain do 
  if Sender = tbtZoom then begin
   EditPointControl := Nil;
   CreatingControlClass := Nil;
   ToolMode := ftmZoom;
  end else
  if Sender = tbtPan then begin
   //EditPointControl := Nil;
   CreatingControlClass := Nil;
   ToolMode := ftmPan;
  end else
  if Sender = tbtShape then begin
   CreatingControlClass := Nil;
   //if SelectedCount = 1 then EditPointControl := Selected[0];
   ToolMode := ftmPointEdit;
  end else begin
   if Sender = tbtArrow then begin
    CreatingControlClass := Nil;
    EditPointControl := Nil;
   end else
   if Sender = tbtLine then
    CreatingControlClass := TFlexCurve
   else
   if Sender = tbtBox then
    CreatingControlClass := TFlexBox
   else
   if Sender = tbtEllipse then
    CreatingControlClass := TFlexEllipse
   else
   if Sender = tbtText then
    CreatingControlClass := TFlexText
   else
   if Sender = tbtPicture then
    CreatingControlClass := TFlexPicture
   else
   if TToolButton(Sender).Tag <> 0 then
    CreatingControlClass := TFlexControlClass(TToolButton(Sender).Tag);
   //if ToolMode in [ftmZoom, ftmZooming, ftmPan, ftmPanning] then
   ToolMode := ftmSelect;
  end;
end;

procedure TfmMain.tstSchemesChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
 fpMain.ActiveScheme := fpMain.Schemes[NewTab];
 AllowChange := true;
end;

procedure TfmMain.miSchemeNewClick(Sender: TObject);
var AName: string;
    Scheme: TFlexScheme;
begin
 Scheme := TFlexScheme.Create(fpMain, fpMain.Schemes, Nil);
 AName := Scheme.Name;
 if InputQuery('Enter new scheme name', 'Name: ', AName) then begin
  Scheme.Name := AName;
  DocChange;
  tstSchemes.TabIndex := fpMain.Schemes.IndexOf(Scheme);
 end else
  Scheme.Free;
end;

procedure TfmMain.miSchemeDeleteClick(Sender: TObject);
var AName: string;
begin
 AName := fpMain.Schemes[tstSchemes.TabIndex].Name;
 if MessageDlg('Delete scheme "'+AName+'"?',
   mtConfirmation, [mbOk, mbCancel], 0) = mrOk then begin
  fpMain.Schemes[tstSchemes.TabIndex].Free;
  DocChange;
 end;
end;

procedure TfmMain.miSchemeRenameClick(Sender: TObject);
var AName: string;
begin
 AName := fpMain.Schemes[tstSchemes.TabIndex].Name;
 if InputQuery('Enter scheme name', 'Name: ', AName) then begin
  fpMain.Schemes[tstSchemes.TabIndex].Name := AName;
  DocChange;
 end;
end;

procedure TfmMain.fpMainDblClick(Sender: TObject);
var SelClass: TClass;
    i: integer;
    Picture: TPicture;
    AText: string;
begin
 if fpMain.ToolMode <> ftmSelect then exit;
 // Process MouseUp
 Application.ProcessMessages;
 // Properties
 if fpMain.SelectedCount = 0 then exit;
 SelClass := fpMain.Selected[0].ClassType;
 for i:=1 to fpMain.SelectedCount-1 do
  if not (fpMain.Selected[i] is SelClass) then exit;
 if fpMain.Selected[0] is TFlexPicture then begin
  // Load picture
  if not opd_Pictures.Execute then exit;
  Picture := TPicture.Create;
  try
   Picture.LoadFromFile(opd_Pictures.Filename);
   // Assign picture
   for i:=0 to fpMain.SelectedCount-1 do
    TFlexPicture(fpMain.Selected[i]).PictureProp.Graphic := Picture.Graphic;
  finally
   Picture.Free;
  end;
 end else
 if fpMain.Selected[0] is TFlexText then begin
  // Edit text
  AText := TFlexText(fpMain.Selected[0]).TextProp.Text;
  if InputQuery('Edit text', 'Text: ', AText) then
   for i:=0 to fpMain.SelectedCount-1 do
    TFlexText(fpMain.Selected[i]).TextProp.Text := AText;
 end;
end;

procedure TfmMain.RebuildColors;
var Count: integer;
    Rows, Cols: integer;
begin
 dgColors.RowCount := 200;
 Count := Length(DefaultPallete);
 Rows := dgColors.VisibleRowCount;
 Cols := Count div Rows + byte(Count mod Rows <> 0);
 dgColors.RowCount := Rows;
 dgColors.ColCount := Cols;
 dgColors.Invalidate;
end;

procedure TfmMain.panColorsResize(Sender: TObject);
begin
 RebuildColors;
end;

procedure TfmMain.sptColorsMoved(Sender: TObject);
begin
 RebuildColors;
end;

procedure TfmMain.dgColorsDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var Index: integer;
    Color: TColor;
begin
 Index := ACol * dgColors.RowCount + ARow;
 with dgColors.Canvas do begin
  if Index <= High(DefaultPallete) then begin
   Pen.Color := clBlack;
   Pen.Style := psSolid;
   Brush.Style := bsClear;
   {$IFDEF VER120}
   Rectangle(Rect.Left, Rect.Top, Rect.Right, Rect.Bottom);
   {$ELSE}
   Rectangle(Rect);
   {$ENDIF}
   InflateRect(Rect, -1, -1);
   Color := DefaultPallete[Index];
   case Color of
    clNone:
      with Rect do begin
       Brush.Color := clWhite;
       Brush.Style := bsSolid;
       FillRect(Rect);
       MoveTo(Left, Top);
       LineTo(Right, Bottom);
       MoveTo(Right, Top-1);
       LineTo(Left-1, Bottom);
      end;
    clDefault:
      begin
       Brush.Color := clWhite;
       Brush.Style := bsSolid;
       FillRect(Rect);
       InflateRect(Rect, -4, 0);
       dec(Rect.Bottom, 2);
       Rect.Top := Rect.Bottom - 2;
       Brush.Color := clBlack;
       FillRect(Rect);
      end;
    else
      begin
       Brush.Color := ColorToRGB(Color);
       Brush.Style := bsSolid;
       FillRect(Rect);
      end;
   end;
  end;
 end;
end;

procedure TfmMain.dgColorsMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Index, i: integer;
    ACol, ARow: integer;
    Color: TColor;
    Control: TFlexControl;
    Brush: TBrushProp;
    Pen: TPenProp;
    PassRec: TPassControlRec;
begin
 dgColors.MouseToCell(X, Y, ACol, ARow);
 Index := ACol * dgColors.RowCount + ARow;
 if Index <= High(DefaultPallete)
  then Color := DefaultPallete[Index]
  else exit;
 if Color = clDefault then
  if cd_Main.Execute
   then Color := cd_Main.Color
   else exit;
 for i:=0 to fpMain.SelectedCount-1 do begin
  Control := fpMain.Selected[i];
  FirstControl(Control, PassRec);
  while Assigned(Control) do begin
   Brush := Control.Props['Brush'] as TBrushProp;
   Pen := Control.Props['Pen'] as TPenProp;
   if (Button = mbLeft) and Assigned(Brush) then begin
    // Fill
    Brush.Method := bmHatch;
    if Color = clNone then
     Brush.Style := bsClear
    else begin
     Brush.Style := bsSolid;
     Brush.Color := ColorToRGB(Color);
    end;
   end else
   if (Button = mbRight) and Assigned(Pen) then begin
    // Outline
    if Color = clNone then
     Pen.Style := psClear
    else begin
     Pen.Style := psSolid;
     Pen.Color := ColorToRGB(Color);
    end;
   end;
   // Next sub-control
   Control := NextControl(PassRec);
  end;
  ClosePassRec(PassRec);
 end;
end;

procedure TfmMain.acFileNewExecute(Sender: TObject);
begin
 if not CheckSave then exit;
 fpMain.NewDocument;
 fpMain.Modified := false;
 CheckTools;
 DocChange;
end;

procedure TfmMain.acFileOpenExecute(Sender: TObject);
begin
 if not CheckSave or not od_Main.Execute then exit;
 fpMain.LoadFromFile(od_Main.Filename);
 FFilename := od_Main.Filename;
 sd_Main.Filename := od_Main.Filename;
 CheckTools;
 DocChange;
end;

procedure TfmMain.acFileSaveExecute(Sender: TObject);
begin
 if not sd_Main.Execute then exit;
 fpMain.SaveToFile(sd_Main.Filename);
 FFilename := sd_Main.Filename;
 od_Main.Filename := sd_Main.Filename;
 CheckTools;
end;

procedure TfmMain.acFileExitExecute(Sender: TObject);
begin
 Close;
end;

procedure TfmMain.acEditCutExecute(Sender: TObject);
begin
 fpMain.CutToClipboard;
end;

procedure TfmMain.acEditCopyExecute(Sender: TObject);
begin
 fpMain.CopyToClipboard;
end;

procedure TfmMain.acEditPasteExecute(Sender: TObject);
begin
 fpMain.PasteFromClipboard;
end;

procedure TfmMain.acEditDeleteExecute(Sender: TObject);
begin
 fpMain.DeleteSelected;
end;

procedure TfmMain.acZoomInExecute(Sender: TObject);
begin
 fpMain.Zoom(fpMain.Scale * 2, Nil);
 sbrMain.Panels[sbpScale].Text := 'Scale: '+IntToStr(fpMain.Scale)+'%';
end;

procedure TfmMain.acZoomOutExecute(Sender: TObject);
begin
 fpMain.Zoom(fpMain.Scale div 2, Nil);
 sbrMain.Panels[sbpScale].Text := 'Scale: '+IntToStr(fpMain.Scale)+'%';
end;

procedure TfmMain.acZoom100Execute(Sender: TObject);
begin
 fpMain.Zoom(100, Nil);
 sbrMain.Panels[sbpScale].Text := 'Scale: '+IntToStr(fpMain.Scale)+'%';
end;

end.
