//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <FlexBase.hpp>
#include <FlexControls.hpp>
#include <FlexUtils.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TfmMain : public TForm
{
__published:	// IDE-managed Components
        TSplitter *sptMain;
        TPanel *panImage;
        TImage *imgView;
        TPanel *panImageCaption;
        TLabel *Label1;
        TStatusBar *sbrMain;
        TPanel *panControls;
        TGroupBox *gbPaintParams;
        TCheckBox *chPaintClipped;
        TCheckBox *chPaintChildren;
        TCheckBox *chPaintSelected;
        TCheckBox *chPaintForExport;
        TGroupBox *gbRenderOptions;
        TCheckBox *chFixedScale;
        TCheckBox *chAutoCenter;
        TTrackBar *trbScale;
        TPanel *Panel1;
        TPanel *panFlexCaption;
        TLabel *Label2;
        TFlexPanel *fpView;
        TEdit *sedScale;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall fpViewResize(TObject *Sender);
        void __fastcall fpViewEndSelectionUpdate(TObject *Sender);
        void __fastcall fpViewNotify(TObject *Sender,
          TFlexControl *Control, TFlexNotify Notify);
        void __fastcall chAutoCenterClick(TObject *Sender);
        void __fastcall chFixedScaleClick(TObject *Sender);
        void __fastcall chPaintOptionClick(TObject *Sender);
        void __fastcall sedScaleChange(TObject *Sender);
        void __fastcall trbScaleChange(TObject *Sender);
private:	// User declarations
        TFlexText *FTextBox;
        TFlexBox *FFrameBox;
        bool FScaleChanging;
        void __fastcall CheckTools();
        void __fastcall SetFixedScale(int Value);
        void __fastcall RepaintImage();
        void __fastcall PanelStretchDraw(TCanvas *ACanvas, TFlexPanel *APanel,
          const TRect *CanvasRect, const TRect *DocRect, int FixedScale = 0,
          bool AutoCenter = false);

public:		// User declarations
        __fastcall TfmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
