//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "FlexMultiPics.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FlexBase"
#pragma resource "*.dfm"
TfmMain *fmMain;
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
        : TForm(Owner)
{
  LoadFlexCursors();
  fpView->InDesign = TRUE;
  CreateMultiPic();
  RebuildImageCombo();
  CheckTools();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::CreateMultiPic(void)
{
  // We strongly recommend to use CppCreate function to create flex-control
  // in C++Builder environment instead of native object creation via
  // Control = new TFlexControl(...). It prevents from some incompatibility in
  // object initialization section in Delphi and C++Builder. You also can use
  // TFlexPanel::CreateControl() method to create flex-controls in definite flex
  // panel.
  FMultiPic = (TFlexMultiPicControl *) TFlexMultiPicControl::CppCreate(
    fpView, fpView->ActiveScheme, fpView->ActiveLayer);
  // new TFlexMultiPicControl(fpView, fpView->ActiveScheme, fpView->ActiveLayer);
  FMultiPic->Left = 10000;
  FMultiPic->Top = 10000;
  FMultiPic->Width = 100000;
  FMultiPic->Height = 100000;
  FMultiPic->IsSelected = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::CheckTools()
{
  //bbEdit->Enabled = cbImages->Items->Count > 0;
  bbDelete->Enabled = cbImages->Items->Count > 0;
  cbImages->Enabled = cbImages->Items->Count > 0;
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::RebuildImageCombo()
{
  cbImages->Items->BeginUpdate();
  try
  {
    // Add new images
    while (cbImages->Items->Count < FMultiPic->ImageCount )
      cbImages->Items->Add(IntToStr(cbImages->Items->Count));
    // Delete extra images
    while (cbImages->Items->Count > FMultiPic->ImageCount)
      cbImages->Items->Delete(cbImages->Items->Count - 1);
    // Set current
    cbImages->ItemIndex = FMultiPic->PictureIndexProp->Value;
  }
  __finally
  {
    cbImages->Items->EndUpdate();
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bbAddClick(TObject *Sender)
{
  if (!opd_Picture->Execute())
    return;

  TPicture *Picture = new TPicture;
  try
  {
    Picture->LoadFromFile(opd_Picture->FileName);
    int Index = FMultiPic->AddImage(Picture);
    FMultiPic->PictureIndexProp->Value = Index;
  }
  __finally
  {
    Picture->Free();
  }
  RebuildImageCombo();
  CheckTools();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::bbDeleteClick(TObject *Sender)
{
  FMultiPic->DeleteImage(FMultiPic->PictureIndexProp->Value);
  RebuildImageCombo();
  CheckTools();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::cbImagesChange(TObject *Sender)
{
  FMultiPic->PictureIndexProp->Value = cbImages->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bbSaveClick(TObject *Sender)
{
  if (!sd_Flex->Execute())
    return;
  fpView->SaveToFile(sd_Flex->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::bbLoadClick(TObject *Sender)
{
  if (!od_Flex->Execute())
    return;
  FMultiPic = NULL;
  fpView->LoadFromFile(od_Flex->FileName);
  // Find first multi picture
  for (int i = 0; i < fpView->ActiveScheme->Count; i++)
    if (fpView->ActiveScheme->Controls[i]->InheritsFrom(
      __classid(TFlexMultiPicControl)))
    {
      FMultiPic = (TFlexMultiPicControl *) fpView->ActiveScheme->Controls[i];
      FMultiPic->IsSelected = TRUE;
      break;
    }
  if (!FMultiPic)
  {
    ShowMessage("TFlexMultiPicControl object not found. Create new");
    CreateMultiPic();
  }
  // Refresh
  sd_Flex->FileName = od_Flex->FileName;
  RebuildImageCombo();
  CheckTools();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::bbEditClick(TObject *Sender)
{
  FMultiPic->PictureListProp->Edit();
  RebuildImageCombo();
  CheckTools();
}
//---------------------------------------------------------------------------

